#!/bin/bash

#  quick-commission.sh
#
#  quick-commission.sh is a commissioning assistant to simplify the curl command commissioning process
# 

function getVal() {
key=$1
num_vals=$2
awk -F"[,:}]" '{for(i=1;i<=NF;i++){if($i~/'$key'\042/){print $(i+1)}}}' | tr -d '"' | sed -n ${num_vals}p
}



#check if commissioning is online
output=$(timeout 5 curl -sk "https://192.168.2.1/api/commissioning" | getVal status 1)

if [[ -z "$output" ]]
then
    echo "ERROR: Commissioning host failed to respond"
    exit 1
fi 

#prompt user for name/pass
read -p 'Username: ' usrname
while [[ $usrname == '' ]]
do
    echo "Username omitted, please enter a username"
    read -p 'Username: ' usrname
done

pass=""
pass2=""
while [[ $pass != $pass2  ||  $pass == ""  ||  $pass2 == "" ]];
do
    read -sp 'Password: ' pass
    if [[ $pass == '' ]]
    then
        printf "\n"
        echo "Password omitted, please enter a password"
    else
        printf "\n"
        read -sp 'Verify Password: ' pass2
        if [[ $pass != $pass2 ]]
        then
            printf "\n"
            echo "Password mismatch. Please reattempt password"
        fi
    fi
done

printf "\n"

#first request for username
output=$(curl -sk -X POST -H "Content-Type: json/application" -d "{\""username"\":"\"$usrname\"," \""aasID"\":"\"\"," \""aasAnswer"\":"\"\""}" https://192.168.2.1:443/api/commissioning)
aastypeDirty=$(echo "$output" | getVal aasType 1)
#remove leading whitespace
aastype="$(echo -e "${aastypeDirty}" | tr -d '[:space:]')"
#error received from the host
while [[ $aastype == "error" ]]
do
    # find out the error type
    aasMsg=$(echo "$output" | getVal aasMsg 1)
    if [[ $aasMsg =~ [1-9] ]]
    then
        output=$(curl -sk -X POST -H "Content-Type: json/application" -d "{\""username"\":"\"$usrname\"," \""aasID"\":"\"\"," \""aasAnswer"\":"\"\""}" https://192.168.2.1:443/api/commissioning)
        aastype=$(echo "$output" | getVal aasType 1)
    else
        echo "ERROR: commissioning left in bad state or gave bad data. Session closed. Please try again."
        exit 1
    fi
done

#preserve aasid on success
aasidDirty=$(echo "$output" | getVal aasID 1)
aasid="$(echo -e "${aasidDirty}" | tr -d '[:space:]')"
#request password
success=0
while [[ $success -lt 2 ]]
do
    output=$(curl -sk -X POST -H "Content-Type: json/application" -d "{\""username"\":"\"$usrname\"," \""aasID"\":\"$aasid\", \""aasAnswer"\":"\"$pass\""}" https://192.168.2.1:443/api/commissioning)
    #error received from the host
    while [[ $aastype == "error" ]]
    do
        aasMsg=$(echo "$output" | getVal aasMsg 1)
        if [[ $aasMsg =~ [1-9] ]]
        # errors exhausted. Closing
        then
            output=$(curl -sk -X POST -H "Content-Type: json/application" -d "{\""username"\":"\"$usrname\"," \""aasID"\":\"$aasid\", \""aasAnswer"\":"\"$pass\""}" https://192.168.2.1:443/api/commissioning)
            aastype=$(echo "$output" | getVal aasType 1)
        else
            echo "ERROR: commissioning left in bad state or gave bad data. Session closed. Please try again."
            exit 1
        fi
    done
    #reset error clock
    errcount=0
    success=$((success+1))
done
echo "Commissioning successful. User Account: $usrname created."
exit 0



